//
//  CustomVideoDelegate.cpp
//  ZegoAvatar
//
//  Created by lihua.wei on 2022/7/19.
//

#include "CustomVideoDelegate.h"
#import "CameraView.h"

CameraView *g_cameraDevice = nil;

@interface CustomVideoDelegate(){
}

@end

@implementation CustomVideoDelegate

/** 初始化摄像头*/
- (instancetype)init{
    self = [super init];
    if (self) {
        if (g_cameraDevice == nil) {
            g_cameraDevice = [CameraView new];
        }
    }
    return self;
}

- (void)onStart:(int)width height:(int)height{
    [g_cameraDevice init: width height:height];
    BOOL result = [g_cameraDevice start:^(CVPixelBufferRef buffer, ZegoImageParam *param) {
        [self sendImageBuffer:buffer param:param];
    }];

    NSLog(@"CustomCamera start, reqwidth: %d, reqheight: %d, result=%d, ",  width, height, result);
}

- (void)onStop{
    [g_cameraDevice stop];
    NSLog(@"CustomCamera stop");
}

@end

