//
//  GoBaseViewController.m
//  GoAvatar
//
//  Created by lihua.wei on 2021/12/2.
//

#import "BaseViewController.h"

@interface BaseViewController () <UIGestureRecognizerDelegate>{
    NSString *viewTitle;
}

@end

@implementation BaseViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor = [UIColor whiteColor];
}

- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
    [self.navigationItem setTitle: [self title]];
}

// 整体标题
- (NSString*) title{
    return viewTitle == nil ? @"ZegoAvatarDemo" : viewTitle;
}

- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
    self.navigationController.interactivePopGestureRecognizer.delegate = self;
}

- (BOOL)gestureRecognizerShouldBegin:(UIGestureRecognizer *)gestureRecognizer {
    return NO;
}

- (id)initWithTitle:(NSString *)title{
    if (self = [self init]) {
        self->viewTitle = title;
    }
    return self;
}

// 设置按钮默认样式
- (UIButton*) addButtonWithTitle: (NSString *) title action: (SEL)action{
    UIButton* btn = [[UIButton alloc] init];
    [btn setTitle: title forState:UIControlStateNormal];
    btn.layer.borderColor = UIColor.blackColor.CGColor;
    btn.layer.borderWidth = 1;
    btn.layer.cornerRadius = 6;
    btn.layer.masksToBounds = YES;
    btn.titleLabel.font = [UIFont systemFontOfSize:14];
    [btn setTitleColor: UIColor.blueColor forState:UIControlStateNormal];
    [btn setTitleColor: UIColor.grayColor forState:UIControlStateDisabled];
    [btn setTitleColor: UIColor.grayColor forState:UIControlStateSelected];
    [btn addTarget:self action:action forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:btn];
    return btn;
}

@end
