//
//  VrlImageHelper.h
//  virtualme
//
//  Created by justinsong on 2021/9/24.
//

#pragma once
#import <UIKit/UIKit.h>

@interface VrlImageHelper : NSObject


/** rgb buffer 转 UIImage*/
+ (UIImage *)imageFromRGBABuffer:(unsigned char*)buffer
                           width:(int)width
                          height:(int)heigth;

/** yuv buffer 转 UIImage*/
+ (UIImage *)imageFromYUVBuffer:(unsigned char*)buffer
                           width:(int)width
                          height:(int)heigth;

/** pixelBuffer 转 UIImage*/
+ (UIImage *)imageFromPixelBuffer:(CVPixelBufferRef)pixelBuffer;


/** 读取相机数据，去除对齐像素, 函数内部会为captureBuffer申请内存，外部负责释放！*/
+ (bool)bufferFromPixelBuffer:(CVPixelBufferRef)pixelBuffer imageBuffer:(unsigned char **)captureBuffer width:(int *)width height:(int *)height channel:(int)channel;


/** pixelbuffer(YUV) -> buffer(BGRA) 函数内部会为captureBuffer申请内存，外部负责释放！*/
+ (bool)bgraBufferFromYUVPixelBuffer:(CVPixelBufferRef)pixelBuffer imageBuffer:(unsigned char **)captureBuffer width:(int *)width height:(int *)height channel:(int)channel;

/** UIimage-> buffer(BGRA) 函数内部会为captureBuffer申请内存，外部负责释放！*/
+ (bool)bgraBufferFromImage:(UIImage *)image imageBuffer:(unsigned char **)captureBuffer width:(int *)width height:(int *)height channel:(int)channel;
    
/** YUV(NV12)-->CIImage--->UIImage */
+ (UIImage *)imageFromYUV:(int)w h:(int)h buffer:(unsigned char *_Nullable)buffer;

/** */
+ (CVPixelBufferRef)imageToRGBPixelBuffer:(UIImage *)image;


@end
