#import <AVFoundation/AVFoundation.h>
#import <QuartzCore/QuartzCore.h>
#import <Metal/Metal.h>
#import <simd/simd.h>

#import "ZegoMetalContext.h"

typedef NS_ENUM(NSInteger, ZegoCaptureVideoFillMode) {
    ZegoCaptureVideoFillMode_GravityResize = 0, //默认值，随画布宽高进行缩放，将画布填满，不考虑视频本身的比例，图像可能变形
    ZegoCaptureVideoFillMode_GravityResizeAspectFill = 1, //随画布宽高进行等比缩放，超出区域被裁剪
    ZegoCaptureVideoFillMode_GravityResizeAspect = 2, //随画布进行等比放大或缩小，对齐上下或者左右，会有黑边
};

@interface ZegoTextureRenderer : NSObject
@property (nonatomic, assign) ZegoCaptureVideoFillMode fillMode;
- (instancetype)initWithLayer:(CAMetalLayer *)layer andContext: (ZegoMetalContext *)context;
- (void)draw: (id<MTLTexture>) inTexture;
@end
