//
//  ZegoTextRequest.h
//  GoAvatar
//
//  Created by lihua.wei on 2023/2/7.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@interface ZegoTextDataModel : NSObject

@property (nonatomic, strong) NSString *audio;
@property (nonatomic, strong) NSArray <NSArray *> *frame_sequence;
@property (nonatomic, assign) NSTimeInterval duration;
@property (nonatomic, assign) NSTimeInterval start;
@property (nonatomic, assign) float frame;

@end

@interface ZegoTextModel : NSObject

@property (nonatomic, assign) NSUInteger code;
@property (nonatomic, assign) NSUInteger unique_id;
@property (nonatomic, strong) NSString *message;
@property (nonatomic, strong) ZegoTextDataModel *data;

@end

@interface ZegoTextRequest : NSObject

- (void)requestBsWithText:(NSString *)text
                    appID:(NSUInteger)appID
                  appSign:(NSString *)appSign
                timestamp:(NSUInteger)timestamp
                voiceType:(NSUInteger)voiceType
                 language:(NSUInteger)language
               sampleRate:(NSUInteger)sampleRate
                    codec:(NSString *)codec
                    nonce:(NSString *)nonce
                    speed:(NSUInteger)speed
                completed:(void(^)(ZegoTextModel *model))completed;

@end

NS_ASSUME_NONNULL_END
