

#import "ManualFaceViewController.h"
#import <ZegoAvatar/ZegoAvatarService.h>
#import <Masonry/Masonry.h>
#import "UIView+Toast.h"



@interface ManualFaceViewController ()

@property (nonatomic, strong) UIView <IZegoAvatarView> *avatarView;
@property (nonatomic, strong) id<IZegoCharacter> character;

@property (nonatomic,strong) UIButton *Browheightup;
@property (nonatomic,strong) UIButton *Browheightdown;
@property (nonatomic,strong) UIButton *EyesSizeup;
@property (nonatomic,strong) UIButton *EyesSizedown;
@property (nonatomic,strong) UIButton *CheekEnlarge;
@property (nonatomic,strong) UIButton *GetDeformationSingleBtn;
@property (nonatomic,strong) UIButton *getDeformationBtn;
@property (nonatomic,strong) UIButton *setDeformationBtn;

@end

@implementation ManualFaceViewController

- (void)viewDidLoad {
    
    [super viewDidLoad];
    
    // 初始化 Avatar
    [self initAvatar];
    
    //设置约束参数
    CGFloat btnw = (self.view.bounds.size.width-20*4)/3;
    CGFloat btnH =44;
    CGFloat margin =20;
    CGFloat marginH =20;
    //设置眉毛高度增加按钮
    _Browheightup = [self addButtonWithTitle: @"眉毛高度增加" action:@selector(Increasebrowheight:)];
    //添加约束
    [_Browheightup mas_makeConstraints:^(MASConstraintMaker *make) {
        //宽度值为btnw
        make.width.mas_equalTo(btnw);
        //高度值为btnH
        make.height.mas_equalTo(btnH);
        //左边距view的值为magin
        make.left.equalTo(self.view).offset(margin);
        //顶部距离avatarView的底部的值为maginH
        make.top.equalTo(self.avatarView.mas_bottom).offset(marginH);
    }];
    
    //设置眉毛高度缩小按钮
    _Browheightdown = [self addButtonWithTitle: @"眉毛高度缩小" action:@selector(Decreasebrowheight:)];
    [_Browheightdown mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(btnw);
        make.height.mas_equalTo(btnH);
        make.left.equalTo(self.view).offset(margin);
        make.top.equalTo(self.Browheightup.mas_bottom).offset(marginH);
    }];
    
    //设置眼睛放大按钮
    _EyesSizeup = [self addButtonWithTitle: @"眼睛放大" action:@selector(IncreaseEyesize:)];
    [_EyesSizeup mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(btnw);
        make.height.mas_equalTo(btnH);
        make.left.equalTo(self.Browheightup.mas_right).offset(margin);
        make.top.equalTo(self.avatarView.mas_bottom).offset(marginH);
    }];
    
    //设置眼睛缩小按钮
    _EyesSizedown= [self addButtonWithTitle: @"眼睛缩小" action:@selector(DecreaseEyesize:)];
    [_EyesSizedown mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(btnw);
        make.height.mas_equalTo(btnH);
        make.left.equalTo(self.Browheightdown.mas_right).offset(margin);
        make.top.equalTo(self.EyesSizeup.mas_bottom)    .offset(marginH);
    }];
    
    //设置双腿伸长按钮
    _CheekEnlarge = [self addButtonWithTitle: @"双腿伸长" action:@selector(IncreaseCheeksize:)];
    [_CheekEnlarge mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(btnw);
        make.height.mas_equalTo(btnH);
        make.left.equalTo(self.EyesSizeup.mas_right).offset(margin);
        make.top.equalTo(self.avatarView.mas_bottom).offset(marginH);
    }];
    
    //获取单个维度
    _GetDeformationSingleBtn= [self addButtonWithTitle: @"获取单个维度" action:@selector(GetDeformationSingleCheeksize:)];
    [_GetDeformationSingleBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(btnw);
        make.height.mas_equalTo(btnH);
        make.left.equalTo(self.EyesSizedown.mas_right).offset(margin);
        make.top.equalTo(self.CheekEnlarge.mas_bottom).offset(marginH);
    }];
    
    //获取身体数据
    _getDeformationBtn = [self addButtonWithTitle: @"获取身体数据" action:@selector(GetDeformationBtnClick)];
    [_getDeformationBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(btnw);
        make.height.mas_equalTo(btnH);
        make.left.equalTo(self.view).offset(margin);
        make.top.equalTo(self.Browheightdown.mas_bottom).offset(marginH);
    }];
    
    //设置身体数据
    _setDeformationBtn = [self addButtonWithTitle: @"重置身体数据" action:@selector(SetDeformationBtnClick)];
    [_setDeformationBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(btnw);
        make.height.mas_equalTo(btnH);
        make.left.equalTo(self.getDeformationBtn.mas_right).offset(margin);
        make.top.equalTo(self.Browheightdown.mas_bottom).offset(marginH);
    }];
}

- (void)viewWillDisappear:(BOOL)animated{
    [super viewWillDisappear:animated];
    // 回收 Avatar
    [_avatarView removeAllCharacter];
    _avatarView = nil;
}

#pragma mark - Avatar

- (void) initAvatar{
    
    // 通过 ZegoAvatarService 单例提供的 createAvatarView 方法创建 IZegoAvatarView 实例对象
    _avatarView = [[ZegoAvatarService sharedInstance] createAvatarView:CGRectMake((self.view.bounds.size.width - 300) / 2/*居中*/, getRectNavAndStatusHight + 40, 300, 300)];
    [self.view addSubview:_avatarView];
    
    // 创建一个 avatar 角色
    NSString *assetBundlesPath = [[[NSBundle mainBundle] bundlePath] stringByAppendingString:@"/assets/qhuman.bundle/AssetBundles/bundle/qbody/Boy.prefab"];
    _character = [[ZegoAvatarService sharedInstance] createCharacter:assetBundlesPath];
    
    // 把角色渲染到 view 上，不然不可见
    [_avatarView setCharacter:_character];
}

#pragma mark - Package

-(void)Increasebrowheight:(UIButton *)sender{
    // 每个维度的 key 值请联系 zego 技术支持获得
    [_character setDeformation:@"faceshape_brow_all_y" value:0.8];
}

-(void)Decreasebrowheight:(UIButton *)sender{
    [_character setDeformation:@"faceshape_brow_all_y" value:-0.8];
}

-(void)IncreaseEyesize:(UIButton *)sender{
    [_character setDeformation:@"faceshape_eye_size" value:0.9];
}

-(void)DecreaseEyesize:(UIButton *)sender{
    [_character setDeformation:@"faceshape_eye_size" value:-0.9];
}

-(void)IncreaseCheeksize:(UIButton *)sender{
    [_character setDeformation:@"bodyshape_leg_Ysize" value:1.0];
}

-(CGFloat)GetDeformationSingleCheeksize:(UIButton *)sender{
    // 这里是拿单个维度的数据，传入维度的 key 值，返回对应的维度 data 值，CGFloat 类型。
    
    CGFloat legYSize = [_character getDeformation:@"bodyshape_leg_Ysize"];
    [self.view makeToast:[NSString stringWithFormat:@"双腿长度数组为：%f", legYSize]];
    return legYSize;
}

- (NSString*)GetDeformationBtnClick {
    // 这里是拿全部维度的数据，返回数据为 NSString 类型，为零的维度则不输出
    NSString *def = [_character getDeformation];
    [self.view makeToast:[NSString stringWithFormat:@"身体数据：%@", def]];
    return def;
}

- (void)SetDeformationBtnClick {
    // 从预先存放好的 kneadDataDefault.json 文件里拿数据，一次性设置很多维度的型变值
    NSString *kneadName = [NSString stringWithFormat:@"kneadDataDefault"];
    NSString *kneadPath = [[NSBundle mainBundle] pathForResource:kneadName ofType:@"json"];
    NSData *data = [[NSData alloc] initWithContentsOfFile:kneadPath];
    NSString *deformation = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
    [_character setDeformation:deformation];
    [self.view makeToast:@"身体数据已重置"];
}


@end
