//
//  MultiAvatarViewController.m
//  ZegoAvatarExample
//
//  Created by zego on 2023/8/11.
//

#import "MultiAvatarViewController.h"
#import <ZegoAvatar/ZegoAvatarService.h>

@interface MultiAvatarViewController ()

@property (nonatomic, strong) UIView <IZegoAvatarView> *avatarView1;
@property (nonatomic, strong) UIView <IZegoAvatarView> *avatarView2;
@property (nonatomic, strong) id<IZegoCharacter> character1;
@property (nonatomic, strong) id<IZegoCharacter> character2;

@end

@implementation MultiAvatarViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    // 初始化 Avatar
    [self initAvatar];
}

- (void)viewWillDisappear:(BOOL)animated{
    [super viewWillDisappear:animated];
    // 回收 Avatar
    [_avatarView1 removeAllCharacter];
    _avatarView1 = nil;
    
    [_avatarView2 removeAllCharacter];
    _avatarView2 = nil;
}


// 初始化 avatar
- (void) initAvatar{
    NSLog(@"AnimationViewController init avatar!!");
    
    // 创建两个 AvatarView，各自添加一个角色
    _avatarView1 = [[ZegoAvatarService sharedInstance] createAvatarView:CGRectMake(self.view.bounds.size.width/4, 120, self.view.bounds.size.width/2, self.view.bounds.size.height/3)];
    [self.view addSubview:_avatarView1];
    _avatarView1.backgroundColor = [UIColor greenColor];
    
    NSString *assetBundlesPath = [[[NSBundle mainBundle] bundlePath] stringByAppendingString:@"/assets/qhuman.bundle/AssetBundles/bundle/qbody/Boy.prefab"];
    _character1 = [[ZegoAvatarService sharedInstance] createCharacter:assetBundlesPath];
    [_avatarView1 setCharacter:_character1];
    
    
    _avatarView2 = [[ZegoAvatarService sharedInstance] createAvatarView:CGRectMake(self.view.bounds.size.width/4, 180 + self.view.bounds.size.height/3, self.view.bounds.size.width/2, self.view.bounds.size.height/3)];
    [self.view addSubview:_avatarView2];
    _avatarView2.backgroundColor = [UIColor yellowColor];
    
    // 创建两个 avatar 角色
    NSString *assetBundlesGirlPath = [[[NSBundle mainBundle] bundlePath] stringByAppendingString:@"/assets/qhuman.bundle/AssetBundles/bundle/qbody/Girl.prefab"];
    _character2 = [[ZegoAvatarService sharedInstance] createCharacter:assetBundlesPath];
    [_avatarView2 setCharacter:_character2];
}

@end
